Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPLegendreStore.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPLegendreStore.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPLegendreStore.cc	(revision 962)
@@ -28,4 +28,6 @@
 // A prototype of the low energy neutron transport model.
 //
+// 080612 SampleDiscreteTwoBody contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #3
+//
 #include "G4NeutronHPLegendreStore.hh"
 #include "G4NeutronHPVector.hh"
@@ -34,4 +36,82 @@
 #include "Randomize.hh"
 #include <iostream>
+
+
+
+//080612TK contribution from Benoit Pirard and Laurent Desorgher (Univ. Bern) #3 
+G4double G4NeutronHPLegendreStore::SampleDiscreteTwoBody (G4double anEnergy)
+{
+  G4double result;
+  
+  G4int i0;
+  G4int low(0), high(0);
+  G4NeutronHPFastLegendre theLeg;
+  for (i0=0; i0<nEnergy; i0++)
+  {
+    high = i0;
+    if(theCoeff[i0].GetEnergy()>anEnergy) break;
+  }
+  low = std::max(0, high-1);
+  G4NeutronHPInterpolator theInt;
+  G4double x, x1, x2;
+  x = anEnergy;
+  x1 = theCoeff[low].GetEnergy();
+  x2 = theCoeff[high].GetEnergy();
+  G4double theNorm = 0;
+  G4double try01=0, try02=0;
+  G4double max1, max2, costh;
+  max1 = 0; max2 = 0;
+  G4int l,m;
+  for(i0=0; i0<601; i0++)
+  {
+      costh = G4double(i0-300)/300.;
+      try01 = 0.5;
+      for(m=0; m<theCoeff[low].GetNumberOfPoly() ; m++)
+      {  
+	  l=m+1;
+	  try01 += (2.*l+1)/2.*theCoeff[low].GetCoeff(m)*theLeg.Evaluate(l, costh);
+      } 
+      if(try01>max1) max1=try01;
+      try02 = 0.5;
+      for(m=0; m<theCoeff[high].GetNumberOfPoly() ; m++)
+      {
+	  l=m+1;
+	  try02 += (2.*l+1)/2.*theCoeff[high].GetCoeff(m)*theLeg.Evaluate(l, costh);
+      }
+      if(try02>max2) max2=try02;
+  } 
+  theNorm = theInt.Interpolate(theManager.GetScheme(high), x, x1, x2, max1, max2);
+  
+  G4double value, random;
+  G4double v1, v2;
+  do
+  {
+    v1 = 0.5;
+    v2 = 0.5;
+    result = 2.*G4UniformRand()-1.;
+    for(m=0; m<theCoeff[low].GetNumberOfPoly() ; m++)
+    {
+	l=m+1;	
+	G4double legend = theLeg.Evaluate(l, result); // @@@ done to avoid optimization error on SUN
+	v1 += (2.*l+1)/2.*theCoeff[low].GetCoeff(m)*legend;
+    } 
+    for(m=0; m<theCoeff[high].GetNumberOfPoly() ; m++)
+    {	
+	l=m+1;
+	G4double legend = theLeg.Evaluate(l, result); // @@@ done to avoid optimization error on SUN
+	v2 += (2.*l+1)/2.*theCoeff[high].GetCoeff(m)*legend;
+    } 
+    // v1 = std::max(0.,v1); // Workaround in case one of the distributions is fully non-physical.
+    // v2 = std::max(0.,v2); 
+    value = theInt.Interpolate(theManager.GetScheme(high), x, x1, x2, v1, v2);
+    random = G4UniformRand();
+    if(0>=theNorm) break; // Workaround for negative cross-section values. @@@@ 31 May 2000
+  }
+  while(random>value/theNorm);
+
+  return result;
+}
+
+
 
 G4double G4NeutronHPLegendreStore::SampleMax (G4double anEnergy)
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNBodyPhaseSpace.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNBodyPhaseSpace.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNBodyPhaseSpace.cc	(revision 962)
@@ -26,5 +26,5 @@
 //
 // $Id: G4NeutronHPNBodyPhaseSpace.cc,v 1.13 2006/06/29 20:53:11 gunter Exp $
-// GEANT4 tag $Name:  $
+// GEANT4 tag $Name: geant4-09-02-ref-02 $
 //
 #include "G4NeutronHPNBodyPhaseSpace.hh"
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNames.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNames.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPNames.cc	(revision 962)
@@ -34,4 +34,5 @@
 //          Natural Abundance data are allowed. by T. Koi
 // 07-07-06 Allow _nat_ final state even for isotoped cross sections by T. Koi
+// 08-09-01 Add protection that deuteron data do not selected for hydrogen and so on by T. Koi
 //
 #include "G4NeutronHPNames.hh"
@@ -319,5 +320,17 @@
           else
           { 
-             G4cout << "NeutronHP: " << reac << " file for Z = " << Z << ", A = " << A << " is not found and NeutronHP will use " << result.GetName() << G4endl;
+             //080901 Add protection that deuteron data do not selected for hydrogen and so on by T. Koi
+             if ( (reac.find("Inelastic") != reac.size() && 
+                   ((Z == 1 && A == 1) || (Z == 2 && A == 4) ) ) 
+                 ||   
+                  (reac.find("Capture") != reac.size() && (Z == 2 && A == 4) ) )
+             {
+                G4String new_name = base+"/"+rest+"0_0_Zero";
+                result.SetName( new_name );
+             }
+             else
+             {
+                G4cout << "NeutronHP: " << reac << " file for Z = " << Z << ", A = " << A << " is not found and NeutronHP will use " << result.GetName() << G4endl;
+             }
           }
        }
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPPhotonDist.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPPhotonDist.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPPhotonDist.cc	(revision 962)
@@ -33,4 +33,7 @@
 // 070606 Add Partial case by T. Koi 
 // 070618 fix memory leaking by T. Koi
+// 080801 fix memory leaking by T. Koi
+// 080801 Correcting data disorder which happened when both InitPartial 
+//        and InitAnglurar methods was called in a same instance by T. Koi
 //
 // there is a lot of unused (and undebugged) code in this file. Kept for the moment just in case. @@
@@ -109,4 +112,5 @@
 void G4NeutronHPPhotonDist::InitAngular(std::ifstream & aDataFile)
 {
+
   G4int i, ii;
   //angular distributions
@@ -115,11 +119,36 @@
   {
     aDataFile >> tabulationType >> nDiscrete2 >> nIso;
-    theShells = new G4double[nDiscrete2];
-    theGammas = new G4double[nDiscrete2];
+//080731
+      if ( theGammas != NULL && nDiscrete2 != nDiscrete ) G4cout << "080731c G4NeutronHPPhotonDist nDiscrete2 != nDiscrete, It looks like something wrong in your NDL files. Please update the latest. If you still have this messages after the update, then please report to Geant4 Hyper News." << G4endl;
+
+      // The order of cross section (InitPartials) and distribution (InitAngular here) data are different, we have to re-coordinate consistent data order.
+      std::vector < G4double > vct_gammas_par; 
+      std::vector < G4double > vct_shells_par; 
+      std::vector < G4int > vct_primary_par; 
+      std::vector < G4int > vct_distype_par; 
+      std::vector < G4NeutronHPVector* > vct_pXS_par;
+      if ( theGammas != NULL ) 
+      {
+         //copy the cross section data 
+         for ( i = 0 ; i < nDiscrete ; i++ )
+         {
+            vct_gammas_par.push_back( theGammas[ i ] );
+            vct_shells_par.push_back( theShells[ i ] );
+            vct_primary_par.push_back( isPrimary[ i ] );
+            vct_distype_par.push_back( disType[ i ] );
+            G4NeutronHPVector* hpv = new G4NeutronHPVector;
+            *hpv = thePartialXsec[ i ];
+            vct_pXS_par.push_back( hpv );
+         }
+      }
+     if ( theGammas == NULL ) theGammas = new G4double[nDiscrete2];
+     if ( theShells == NULL ) theShells = new G4double[nDiscrete2];
+//080731
+
     for (i=0; i< nIso; i++) // isotropic photons
     {
-        aDataFile >> theGammas[i] >> theShells[i];
-        theGammas[i]*=eV;
-        theShells[i]*=eV;
+       aDataFile >> theGammas[i] >> theShells[i];
+       theGammas[i]*=eV;
+       theShells[i]*=eV;
     }
     nNeu = new G4int [nDiscrete2-nIso];
@@ -157,4 +186,29 @@
       }
     }
+//080731
+     if ( vct_gammas_par.size() > 0 ) 
+     {
+        //Reordering cross section data to corrsponding distribution data 
+        for ( i = 0 ; i < nDiscrete ; i++ ) 
+        {
+           for ( G4int j = 0 ; j < nDiscrete ; j++ )  
+           {
+              // Checking gamma and shell to identification 
+              if ( theGammas[ i ] == vct_gammas_par [ j ] && theShells [ i ] == vct_shells_par[ j ] )
+              {
+                 isPrimary [ i ] = vct_primary_par [ j ];
+                 disType [ i ] = vct_distype_par [ j ];
+                 thePartialXsec[ i ] = ( *( vct_pXS_par[ j ] ) );
+              }
+           }
+        }
+        //Garbage collection 
+        for ( std::vector < G4NeutronHPVector* >::iterator 
+           it = vct_pXS_par.begin() ; it != vct_pXS_par.end() ; it++ )
+        {
+           delete *it;
+        }
+     }
+//080731
   }
 }
@@ -188,4 +242,5 @@
 void G4NeutronHPPhotonDist::InitPartials(std::ifstream & aDataFile)
 {
+
   //G4cout << "G4NeutronHPPhotonDist::InitPartials " << G4endl;
   aDataFile >> nDiscrete >> targetMass;
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPProduct.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPProduct.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPProduct.cc	(revision 962)
@@ -27,4 +27,13 @@
 // J.P. Wellisch, Nov-1996
 // A prototype of the low energy neutron transport model.
+//
+// 080718 As for secondary photons, if its mean value has a value of integer, 
+//        then a sampling of multiplicity that based on Poisson Distribution 
+//        is not carried out and the mean is used as a multiplicity.
+//        modified by T. Koi.
+// 080721 Using ClearHistories() methodl for limiting the sum of secondary energies
+//        modified by T. Koi.
+// 080901 bug fix of too many secnodaries production in nd reactinos by T. Koi
+//
 #include "G4NeutronHPProduct.hh" 
 #include "G4Poisson.hh"
@@ -38,5 +47,17 @@
   G4int multi;
   multi = G4int(mean+0.0001);
-  if(theMassCode==0) multi = G4Poisson(mean); // @@@@gammas. please X-check this
+  //if(theMassCode==0) multi = G4Poisson(mean); // @@@@gammas. please X-check this
+  //080718
+  if ( theMassCode == 0 )
+  { 
+     if ( G4int ( mean ) == mean )
+     {
+        multi = (G4int) mean;
+     }
+     else
+     {
+        multi = G4Poisson ( mean ); 
+     }
+  }
   theDist->SetTarget(theTarget);
   theDist->SetNeutron(theNeutron);
@@ -46,4 +67,5 @@
   theCurrentMultiplicity = static_cast<G4int>(mean);
   G4ReactionProduct * tmp;
+  theDist->ClearHistories();
   for(i=0;i<multi;i++)
   {
@@ -56,4 +78,6 @@
     delete  tmp;
   }
+/*
+//080901 TK Comment out, too many secondaries are produced in deuteron reactions
   if(theTarget->GetMass()<2*GeV) // @@@ take care of residuals in all cases
   {
@@ -62,4 +86,5 @@
     if(tmp != 0) { result->push_back(tmp); }
   }
+*/
   return result;
 }
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPThermalScattering.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPThermalScattering.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPThermalScattering.cc	(revision 962)
@@ -39,4 +39,5 @@
 
 // 070625 Fix memory leaking at destructor by T. Koi 
+// 081201 Fix memory leaking at destructor by T. Koi 
 
 #include "G4NeutronHPThermalScattering.hh"
@@ -103,7 +104,5 @@
 {
 
-   { // separate name scope of it 
-   std::map < G4int , std::map < G4double , std::vector < E_isoAng* >* >* >::iterator it;
-   for ( it = incoherentFSs.begin() ; it != incoherentFSs.end() ; it++ )
+   for ( std::map < G4int , std::map < G4double , std::vector < E_isoAng* >* >* >::iterator it = incoherentFSs.begin() ; it != incoherentFSs.end() ; it++ )
    {
       std::map < G4double , std::vector < E_isoAng* >* >::iterator itt;
@@ -119,9 +118,6 @@
       delete it->second;
    }
-   }
-
-   {
-   std::map < G4int , std::map < G4double , std::vector < std::pair< G4double , G4double >* >* >* >::iterator it;
-   for ( it = coherentFSs.begin() ; it != coherentFSs.end() ; it++ )
+
+   for ( std::map < G4int , std::map < G4double , std::vector < std::pair< G4double , G4double >* >* >* >::iterator it = coherentFSs.begin() ; it != coherentFSs.end() ; it++ )
    {
       std::map < G4double , std::vector < std::pair< G4double , G4double >* >* >::iterator itt;
@@ -137,9 +133,6 @@
       delete it->second;
    }
-   }
-
-   {
-   std::map < G4int ,  std::map < G4double , std::vector < E_P_E_isoAng* >* >* >::iterator it;
-   for ( it = inelasticFSs.begin() ; it != inelasticFSs.end() ; it++ )
+
+   for ( std::map < G4int ,  std::map < G4double , std::vector < E_P_E_isoAng* >* >* >::iterator it = inelasticFSs.begin() ; it != inelasticFSs.end() ; it++ )
    {
       std::map < G4double , std::vector < E_P_E_isoAng* >* >::iterator itt;
@@ -160,6 +153,6 @@
       delete it->second;
    }
-   }
-
+
+   delete theHPElastic;
    delete theXSection;
 }
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPVector.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPVector.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPVector.cc	(revision 962)
@@ -29,4 +29,5 @@
 //
 // 070523 bug fix for G4FPE_DEBUG on by A. Howard ( and T. Koi)
+// 080808 bug fix in Sample() and GetXsec() by T. Koi
 //
 #include "G4NeutronHPVector.hh"
@@ -170,5 +171,7 @@
       //if( (theData[high].GetX()-theData[low].GetX())/theData[high].GetX() < 0.000001)
       if ( theData[high].GetX() !=0 
-       &&( theData[high].GetX()-theData[low].GetX())/theData[high].GetX() < 0.000001)
+       //080808 TKDB
+       //&&( theData[high].GetX()-theData[low].GetX())/theData[high].GetX() < 0.000001)
+       &&( std::abs( (theData[high].GetX()-theData[low].GetX())/theData[high].GetX() ) < 0.000001 ) )
       {
         y = theData[low].GetY();
@@ -366,7 +369,9 @@
       do
       {
+//080808
+/*
+        G4double rand;
         G4double value, test, baseline;
         baseline = theData[GetVectorLength()-1].GetX()-theData[0].GetX();
-        G4double rand;
         do
         {
@@ -379,4 +384,41 @@
         while( test < rand && test > 0 );
         result = value;
+*/
+        G4double rand;
+        G4double value, test;
+        do 
+        {
+           rand = G4UniformRand();
+           G4int ibin = -1;
+           for ( G4int i = 0 ; i < GetVectorLength() ; i++ )
+           {
+              if ( rand < theIntegral[i] ) 
+              {
+                 ibin = i; 
+                 break;
+              }
+           }
+           if ( ibin < 0 ) G4cout << "TKDB 080807 " << rand << G4endl; 
+           // result 
+           rand = G4UniformRand();
+           G4double x1, x2; 
+           if ( ibin == 0 ) 
+           {
+              x1 = theData[ ibin ].GetX(); 
+              value = x1; 
+              break;
+           }
+           else 
+           {
+              x1 = theData[ ibin-1 ].GetX();
+           }
+           
+           x2 = theData[ ibin ].GetX();
+           value = rand * ( x2 - x1 ) + x1;
+           test = GetY ( value ) / std::max ( GetY( ibin-1 ) , GetY ( ibin ) ); 
+        }
+        while ( G4UniformRand() > test );
+        result = value;
+//080807
       }
       while(IsBlocked(result));
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLCaptureData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLCaptureData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLCaptureData.cc	(revision 962)
@@ -29,4 +29,5 @@
 //          If NeutronHP data do not available for an element, then Low Energy 
 //          Parameterization models handle the interactions of the element.
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 
@@ -89,5 +90,5 @@
 
 #include "G4Nucleus.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4Neutron.hh"
 #include "G4Electron.hh"
@@ -114,5 +115,5 @@
   G4double theZ = anE->GetZ();
   G4double eleMass; 
-  eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
+  eleMass = ( G4NucleiProperties::GetNuclearMass( static_cast<G4int>(theA+eps), static_cast<G4int>(theZ+eps))
 	     ) / G4Neutron::Neutron()->GetPDGMass();
   
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLEInelasticData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLEInelasticData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLEInelasticData.cc	(revision 962)
@@ -29,4 +29,5 @@
 //          If NeutronHP data do not available for an element, then Low Energy 
 //          Parameterization models handle the interactions of the element.
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 
@@ -133,5 +134,5 @@
 
 #include "G4Nucleus.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4Neutron.hh"
 #include "G4Electron.hh"
@@ -158,5 +159,5 @@
   G4double theZ = anE->GetZ();
   G4double eleMass; 
-  eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
+  eleMass = ( G4NucleiProperties::GetNuclearMass(static_cast<G4int>(theA+eps), static_cast<G4int>(theZ+eps))
 	     ) / G4Neutron::Neutron()->GetPDGMass();
   
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLElasticData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLElasticData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLElasticData.cc	(revision 962)
@@ -29,4 +29,5 @@
 //          If NeutronHP data do not available for an element, then Low Energy 
 //          Parameterization models handle the interactions of the element.
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 
@@ -89,5 +90,5 @@
 
 #include "G4Nucleus.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4Neutron.hh"
 #include "G4Electron.hh"
@@ -114,5 +115,5 @@
   G4double theZ = anE->GetZ();
   G4double eleMass; 
-  eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
+  eleMass = ( G4NucleiProperties::GetNuclearMass(static_cast<G4int>(theA+eps), static_cast<G4int>(theZ+eps))
 	     ) / G4Neutron::Neutron()->GetPDGMass();
   
Index: trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLFissionData.cc
===================================================================
--- trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLFissionData.cc	(revision 819)
+++ trunk/source/processes/hadronic/models/neutron_hp/src/G4NeutronHPorLFissionData.cc	(revision 962)
@@ -29,4 +29,5 @@
 //          If NeutronHP data do not available for an element, then Low Energy 
 //          Parameterization models handle the interactions of the element.
+// 081024 G4NucleiPropertiesTable:: to G4NucleiProperties::
 //
 
@@ -89,5 +90,5 @@
 
 #include "G4Nucleus.hh"
-#include "G4NucleiPropertiesTable.hh"
+#include "G4NucleiProperties.hh"
 #include "G4Neutron.hh"
 #include "G4Electron.hh"
@@ -114,5 +115,5 @@
   G4double theZ = anE->GetZ();
   G4double eleMass; 
-  eleMass = ( G4NucleiPropertiesTable::GetNuclearMass(static_cast<G4int>(theZ+eps), static_cast<G4int>(theA+eps))
+  eleMass = ( G4NucleiProperties::GetNuclearMass(static_cast<G4int>(theA+eps), static_cast<G4int>(theZ+eps))
 	     ) / G4Neutron::Neutron()->GetPDGMass();
   
